Range.eql? and Range.== bug with subclasses
Description

=begin

Contrary to the documentation (and to what | would expect):

class TrivialRangeSubclass < Range
end

TrivialRangeSubclass.new(0,1) == Range.new(0,1) # ==> false

This bug is present in the current versions of ruby 1.8.7 and 1.9.1. As a matter of curiosity, | checked both JRuby (1.1.6) and rubinius
(0.10.0) and they both return true (as they should).

Although I'm not familiar with the source code, it seams like a simple change, so I've included a patch for the 1.9.1 version. | hope |
did things correctly! Changelog could read like:

Mon Feb 16 14:35:35 2009 Marc-Andre Lafortune ruby-lang@marc-andre.ca

* range.c (range_eql, range_eq): fixed equality to work for
subclasses of Range.

* test/ruby/test_range.rb: add assertions for above.

Thank you!
=end

History

#1 - 05/24/2009 06:30 AM - marcandre (Marc-Andre Lafortune)

=begin
This change was made to bring Range#== and #eq|? in line with the same methods for Array, Hash, String or Time in regards to subclasses. They
should follow the same pattern unless there is a crucial reason not to, and in that case it must be clearly documented.

Additionally, note that String#==, for example, has the same explicit requirement in the documentation that the compared object "is a" String for == to
return true. Other instances in the documentation also concur that "is a" should be understood as "is_a?", e.g. String#=~.
=end

#2 - 07/16/2009 05:37 PM - yugui (Yuki Sonoda)
- Status changed from Open to Closed
- Assignee set to yugui (Yuki Sonoda)

- Target version changed from 2.0.0 to 1.9.2

=begin
=end

#3 - 08/02/2009 08:31 PM - runpaint (Run Paint Run Run)

=begin
Was this meant to be closed? It doesn't appear to have been resolved.
=end
#4 - 08/05/2009 03:19 AM - ujihisa (Tatsuhiro Ujihisa)

=begin
Current documentations don't mention about a subclass of Range.
http://www.ruby-doc.or re/cl Range.html#M

http://doc.okkez.net/191/view/method/Range/i/=3d=3d

Actually the Japanese one was fixed not to mention about a subclass of Range in May. http://redmine.ruby-lang.org/issues/show/1446
=end

#5 - 08/05/2009 05:40 AM - marcandre (Marc-Andre Lafortune)

=begin
Thanks Ujihisa for these links.

The fact that the doc doesn't mention the behavior for subclasses (which is true as well for String, Array, Hash, Time) doesn't change what the best
behavior should be.

Could this ticket be set back to "Open", since no change appears to have taken place and no justification for the current behavior was given? Thanks
=end

Files

ruby-changes.patch 1.16 KB 02/17/2009 marcandre (Marc-Andre Lafortune)
